/*
 * $Id: pllolcode.h,v 1.20 2008/02/05 12:41:51 eggyknap Exp $
 */

#ifndef PLLOLCODE_H
#define PLOLCODE_H
#include "postgres.h"


#define NUMBR2YARN(orig, res, reslen)	snprintf(res, reslen, "%d", orig)
#define NUMBAR2YARN(orig, res, reslen)	snprintf(res, reslen, "%f", orig)
#define TROOF2YARN(orig, res, reslen)	((orig != 0) ? snprintf(res, reslen, "WIN") : snprintf(res, reslen, "FAIL"))

#define NUMBAR2NUMBR(val)	((int) val)
#define TROOF2NUMBR(val)	((val != 0) ? 1 : 0)
#define YARN2NUMBR(val)		((int) strtol(val, NULL, 10))

#define NUMBR2NUMBAR(val)	((double) val)
#define TROOF2NUMBAR(val)	((val != 0) ? 1.0 : 0.0)
#define YARN2NUMBAR(val)	(strtod(val, NULL))

#define NUMBAR2TROOF(val)	((val != 0) ? lolWIN : lolFAIL)
/* TODO: Error checking */
#define YARN2TROOF(val)		((strlen(val) > 0) ? lolWIN : lolFAIL)
#define N00B2TROOF		(lolFAIL)

typedef int NodeType;

typedef union {
		int numbrVal;
		double numbarVal;
		char *yarnVal;
	} NodeVal;

typedef struct lolNode lolNode;

typedef struct lolNodeList {
	int length;
	lolNode *head;
	lolNode *tail;
} lolNodeList;	

struct lolNode {
	NodeType node_type;
	struct lolNode *next;
	/* list for sub-nodes */
	lolNodeList *list;
	NodeVal nodeVal;
};

/* Symbol table related stuff */

typedef enum { ident_YARN, ident_NUMBR, ident_NUMBAR, ident_TROOF, ident_NOOB } IdentType;

typedef struct lolIdent {
	char *name;
	IdentType type;
	NodeVal value;
} lolIdent;

typedef enum { lolFAIL, lolWIN } lolTroof;

extern lolIdent *returnVal;

void lolSetVar(char *name, IdentType type, NodeVal value);
lolIdent *lolGetVar(char *name);
void lolDeclareVar(char *name);
void lolInitVars(void);
char *lolVarGetString(lolIdent *var, bool expl);
double lolVarGetNumbar(lolIdent *var, bool expl);
int lolVarGetNumbr(lolIdent *var, bool expl);
lolTroof lolVarGetTroof(lolIdent *var);
bool lolVarGetBool(lolIdent *var);

extern lolIdent *IT;

extern char *scanbuf;
extern int scanbuflen;
char stringbuf[255];
extern char *pllolcode_yytext;

extern lolNodeList *lolListAppend(lolNodeList *list, lolNode *node);
extern lolNodeList *lolMakeList(lolNode *node);
extern lolNodeList *lolMakeTwoNodeList(lolNode *node1, lolNode *node2);
extern void printSymbolTable(void);

extern void LOLifyDatum(Datum val, bool isnull, Oid typeoid, char *lolVarName);
extern void LOLifyString(char *str, Oid typeoid, char *lolVarName);

extern int   pllolcode_yylex_destroy(void);
#endif
